function PROT_TRFetcher() {
this.debugZone = "trfetcher";
this.lookupserverURL_ = PROT_globalStore.getLookupserverURL();
this.protocol4RegExp_ = new RegExp("([^:]+):\\d+:(.*)$");
}
PROT_TRFetcher.prototype.extraQueryParams = {
sourceid: "firefox-antiphish",
features: "TrustRank",
client: "navclient-auto-ape"
};
PROT_TRFetcher.prototype.getRequestURL_ = function(url) {
var requestURL = this.lookupserverURL_;
for (var param in this.extraQueryParams)
requestURL += param + "=" + this.extraQueryParams[param] + "&";
requestURL += "q=" + encodeURIComponent(url);
return requestURL;
};
PROT_TRFetcher.prototype.get = function(forPage, callback) {
var url = this.getRequestURL_(forPage);
var closure = BindToObject(this.onFetchComplete_, this, callback);
(new PROT_XMLFetcher()).get(url, closure);
G_Debug(this, "Fetching TR: " + url);
};
PROT_TRFetcher.prototype.onFetchComplete_ = function(callback, responseText) {
var responseObj = this.extractResponse_(responseText);
G_Debug(this, "TR Response:");
for (var field in responseObj)
G_Debug(this, field + "=" + responseObj[field]);
callback(responseObj);
};
PROT_TRFetcher.prototype.extractResponse_ = function(responseText) {
if (!responseText)
return null;
var response = {};
var numFound = 0;
var lines = responseText.split("\n");
for (var i=0; i < lines.length; i++)
if (this.protocol4RegExp_.exec(lines[i])) {
response[RegExp.$1] = RegExp.$2;
numFound++;
}
return numFound ? response : null;
};
function TEST_PROT_TRFetcher() {
if (G_GDEBUG) {
var z = "trfetcher UNITTEST";
G_debugService.enableZone(z);
G_Debug(z, "Starting");
var fetcher = new PROT_TRFetcher();
var fakeResponse = "foo:3:foo\nbar:3:bar\nbaz:1:b";
var fields = fetcher.extractResponse_(fakeResponse);
G_Assert("unittest", fields["foo"] == "foo", "Bad parse: foo");
G_Assert("unittest", fields["bar"] == "bar", "Bad parse: bar");
G_Assert("unittest", fields["baz"] == "b", "Bad parse: baz");
G_Assert("unitest", !fields["yourmom"], "Bad parse: yourmom");
fakeResponse = "";
fields = fetcher.extractResponse_(fakeResponse);
G_Assert("unittest", !fields, "Result object should've been null");
G_Debug(z, "PASSED");
}
}
